/////////////////////////USE IN APP///////////////////////////////
//Mifi接口调用地址头
var urlHeadAjax = null;
//广告接口调用地址头
var adUrlHead = "http://api.bigbang-tech.com/lbs/rest";
var statUrlHead = "http://api.bigbang-tech.com/base/rest";

function getUrlHeadAjax(){
	var rst;
	if (urlHeadAjax){
		rst = urlHeadAjax;
	} else {
		var hostip = getMifiString("hostip");
		if (hostip == "" || hostip == null)
			hostip = "192.168.0.1";
		
		urlHeadAjax = "http://" + hostip + "/json-rpc";
		rst = urlHeadAjax;
	}
	
	return rst;
}

/** 
* url: 特定功能的Url，如：/wifi/status 
 * callback: 回调函数 
 * requestType: The type of request to make ("POST" or "GET"), default is "GET". 
 * requestJson: 请求参数
 * urlHeadType: 为null则调用地址头采用Mifi接口的；否则: adUrlHead。
 */
function mifiRequest(url, callback, requestType, requestJson, urlHeadType, recallCount) {
	smartAjaxLog(url, requestJson, "request");
	if (recallCount == null)
		recallCount = 1;
	
	if (requestType == null)
		requestType = "GET";

	var headers;
	var contentType;
	if (requestType == "POST") {
		contentType = "application/json;charset=UTF-8";
	}

	var postData = "";
	if (requestJson != null) {
		postData = JSON.stringify(requestJson);
	}
	/*
	if (url.charAt(0) == '/') {
		url = url.substr(1, url.length-1);
	}
	url = url.replace(/\//g, "_");
	var hostip = getMifiString("hostip");
	var newurl = getMifiString(url);
	*/
	
	var aUrlHead = getUrlHeadAjax();
	if (urlHeadType == 1){
		aUrlHead = adUrlHead;
	} else if (urlHeadType == 2){
		aUrlHead = statUrlHead;
	}
	
	var timeCount = 1500;
	if (url.indexOf("/sms/get") == 0){
		timeCount = 3000;
	}
	
	if (callback) { // async call
		$.ajax({
			url : aUrlHead + url, //hostip + newurl,
			async : true,
			type : requestType,
			data : postData,
			processData: true,
			contentType : contentType,
			timeout : timeCount,
			error : function() {
            	var recallHint = " recallCount:" + recallCount;
            	mifiLog(Base64.toBase64("Mifi Http Request Failed: url("+aUrlHead+url+") async "+requestType+" requestData("+postData+")" + recallHint));
                
                if (recallCount > 0){
					recallCount--;
					mifiRequest(url, callback, requestType, requestJson, urlHeadType, recallCount);
				} else {
					errorProcess(url, urlHeadType);
				}
			},
			success : function(responseJson) {
				smartAjaxLog(url, responseJson, "response");
				
				if (judge(responseJson, url, urlHeadType))
					callback(responseJson);
                else {
                	mifiLog(Base64.toBase64("Mifi Http Response Error: url("+aUrlHead+url+") async "+requestType+" requestData("+postData+")"+" responseData("+responseJson+")"));
                }
			}
		});
	} else { // sync call
		var rst;
		$.ajax({
			url : aUrlHead + url, //hostip + newurl,
			async : false,
			type : requestType,
			data : postData,
			contentType : contentType,
			timeout : 3000,
			error : function() {
				mifiLog(Base64.toBase64("Mifi Http Request Failed: url("+aUrlHead+url+") async "+requestType+" requestData("+postData+")"));
				
				errorProcess(url, urlHeadType);
			},
			success : function(responseJson) {
				smartAjaxLog(url, responseJson, "response");
				
				if (judge(responseJson, url, urlHeadType))
					rst = responseJson;
                else {
                	mifiLog(Base64.toBase64("Mifi Http Response Error: url("+aUrlHead+url+") async "+requestType+" requestData("+postData+")"+" responseData("+responseJson+")"));
                }
			}
		});

		return rst;
	}
}

function judge(responseJson, url, urlHeadType){
	var rst = false;
	if (urlHeadType){
		rst = true;
	} else {
		if (responseJson && responseJson.errorCode == 0){
			rst = true;
		} else if (url == "/admin/login" || url.indexOf("/admin/changepassword") == 0){
			rst = true;
		} else {
			errorProcess(url, urlHeadType, responseJson && responseJson.errorCode);
		}
	}
	
	return rst;
}

function errorProcess(url, urlHeadType, validErrorCode){
	if (!urlHeadType){
		if (window.location.href.indexOf("index.html") >= 0){
			if (url == "/status"){
				showNotValidStatus();
			} else {
				signNotLogging();
			}
		} else if (window.location.href.indexOf("login.html") >= 0){
			//donothing
		} else {
			if (getMifiString("mifiState") != "0" && !validErrorCode)
				window.location = "index.html";
		}
	}
}

function getMifiString(c_name) {
	var rst = "";
	try{
		if (window.MifiHttp)
			rst = window.MifiHttp.getString(c_name, "");
		else
			rst = localStorage.getItem(c_name);
	} catch (e){
		alert(e);
	}
	
	return rst;
}

function setMifiString(c_name, value, expiredays) {
	try{
		if (window.MifiHttp)
			window.MifiHttp.setString(c_name, value);
		else
			localStorage.setItem(c_name, value);
	} catch (e){
	}
	
}

function getApikey(){
	return getMifiString("apikey");
}

function json2Str(jsonData){
	return JSON.stringify(jsonData).replace(/,/g, ",\n");
}

function _gotoNewBrowserUrl(aUrl){
	return MifiHttp.browser(aUrl);
}

function smartAjaxLog(url, jsonObj, title){
	try {
		//if (url.indexOf("/mobiledata/sync") >= 0){
		mifiLog(Base64.toBase64("Mifi ajax:[" + url + "]" + title + "  " + JSON.stringify(jsonObj)));
		//}
	} catch (e) {
    }
}

function mifiLog(s){
	try {
		//MifiHttp.log(s);
	} catch (e) {
    }
}

