var _requestJson;
var _ulShowing = false;

$(function(){
	$('.r2 fieldset div div').click(function(){
		if ($("#dhcp").is(":checked")){
			_ulShowing = true;
			if ($(this).next('ul').is(":visible"))
				$(this).next('ul').hide();
			else
				$(this).next('ul').show();
		}
	});
	
	// 点击下拉选项栏，值赋
	$('.r2 fieldset ul li').click(function(){
		$(this).parent().hide();
		var desc = $(this).text();
		_requestJson.dhcpLeaseTime = parseInt($(this).attr("data-secs"));
		$(this).parent().prev().find('span').text(desc);
	});
	
	$("div#bd").click(function(){
		if (_ulShowing){
			_ulShowing = false;
		} else if ($(".r2 fieldset ul").is(":visible")){
			$(".r2 fieldset ul").hide();
		}
	});
	
	$('div.save div').click(function(){
		var errInfo = null;
		
		if (!testIp($("#ip").val())){
			errInfo = "IP值不正确";
		} else if (!testIp($("#subnet").val())){
			errInfo = "子网掩码不正确";
		} else if (!testIp($("#dns").val())){
			errInfo = "DNS不正确";
		} else if (!testIp($("#ipFrom").val())){
			errInfo = "DHCP地址起始值不正确";
		} else if (!testIp($("#ipTo").val())){
			errInfo = "DHCP地址终止值不正确";
		} else if ($("#ipFrom").val() >= $("#ipTo").val()){
			errInfo = "DHCP地址起始值必须<br>小于DHCP地址终止值";
		}
		
		if (errInfo){
			$("#hintinfo").html(errInfo);
			$(".cancel-btn").val("关闭");
			$(".cancel-btn").css("margin-left", "5em");
			$(".exit-btn").hide();
		} else {		
			$("#hintinfo").html("保存设置内容 <br>是否继续？");
			$(".cancel-btn").css("margin-left", "0em");
			$(".cancel-btn").val("取 消");
			$(".exit-btn").show();
		}
		
		$(".mark,.hintdialog").show();
	});
	
	mifiRequest("/dhcp/status" + "?apikey=" + getApikey(), showDhcpStatus);
});

function testIp(ipAddress){
	var rst = false;
	var re =  /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;  
	if(re.test(ipAddress)){  
	    rst = true;  
	}
	
	return rst;
}

function showDhcpStatus(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	_requestJson = {};
	_requestJson.enabled = result.enabled;
	_requestJson.ip = result.ip;
	_requestJson.subnetMask = result.subnetMask;
	_requestJson.dns = result.dns;
	_requestJson.dhcpLeaseTime = result.dhcpLeaseTime;
	_requestJson.ipAddressRange = result.ipAddressRange;
	
	$("#dhcp").prop("checked", result.enabled);
	$("#ip").val(result.ip);
	$("#subnet").val(result.subnetMask);
	$("#dns").val(result.dns);
	var leaseDesc = getLeaseDesc(result.dhcpLeaseTime);
	$("#lease").html(leaseDesc);
	
	$("input[name=radio]").each(function(){
		if (leaseDesc == $(this).parent().find("label").html()){
			$(this).prop("checked", true);
		}
	});
	
	if (result.ipAddressRange.length == 2){
		$("#ipFrom").val(result.ipAddressRange[0]);
		$("#ipTo").val(result.ipAddressRange[1]);
	}
	
	changeEnabled();
}

function getLeaseDesc(lease){
	var rst = "";
	var remain = lease;
	var count = Math.floor(remain / (7 * 24 * 60 * 60));
	if (count > 0){
		rst += count + "周";
		remain = lease - 7 * 24 * 60 * 60 * count;
	}
	
	count = Math.floor(remain / (24 * 60 * 60));
	if (count > 0){
		rst += count + "天";
		remain = lease -24 * 60 * 60 * count;
	}
	
	count = Math.floor(remain / (60 * 60));
	if (count > 0){
		rst += count + "小时";
		remain = lease - 60 * 60 * count;
	}
	
	count = Math.floor(remain / (60));
	if (count > 0){
		rst += count + "分钟";
		remain = lease - 60 * count;
	}
	
	return rst;
}

function saveOk(){
	$('.mark,.hintdialog').hide();
	
	_requestJson.enabled = $("#dhcp").is(":checked");
	_requestJson.ip = $("#ip").val();
	_requestJson.subnetMask = $("#subnet").val();
	_requestJson.dns = $("#dns").val();
	var arr = [];
	arr[0] = $("#ipFrom").val();
	arr[1] = $("#ipTo").val();
	_requestJson.ipAddressRange = arr;
	
	mifiRequest("/dhcp/set" + "?apikey=" + getApikey(), function(rstJson){
		if (rstJson.errorCode != 0)
			return;
		$('.mark,.restart').show();
	}, "POST", _requestJson);
}

function saveCancel(){
	$('.mark,.hintdialog').hide();
}

function changeEnabled(){
	var enabled = $("#dhcp").is(":checked");
	
	$(".r2 input:text").prop('disabled',!enabled);
	$(".r2 input:text").css("background-color", enabled ? "#FFF" : "rgb(235,235,228)");
	$(".r2 div#divLease").css("background-color", enabled ? "#FFF" : "rgb(235,235,228)");
}