var ONEM = 1024 * 1024;
var _logged = false;
var _notValid = false;
var _initting = true;
var _waked = true;

$(function(){
	setMifiString("curLocation", "index.html");
	setNotValid(true);
	_initting = true;
	
	// 判断是否为登录状态
	$('.hd-ico-l').click(function(){
		if (!_notValid){
			var classname=$(this).children().prop('class');
			if (classname=='user') {
				switchToLogin();
			} else {
				showMark();
				$('.exitlogin').show();
			}
		}
	});

	//signNotLogging();
	init();
	mifiRequest("/status",showStatus);
	setTimeout(function () {
		initAd();
	}, 5000);
});

function queryNewMsg(rstJson){
	try{
		if (rstJson.errorCode != 0)
			return;
		
		var result = rstJson.result;
		if (result && result.messages){
			_messages = result.messages;
			
			if (_messages.length > 0){
				var message = _messages[0];
				if (message.timestamp != getMifiString("msgTimestamp")){
					setMifiString("msgTimestamp", message.timestamp);
					$('.hd-ico-r i').css("background-image", "url('images/message-active-newmsg.png')");
				}
			}
		}
	} catch(err){
		
	}
}

function setLogged(logged){
	_initting = false;
	
	_logged = logged;
	setMifiString("mifiState", logged ? "2" : "1");
}

function setNotValid(notValid){
	_initting = false;
	
	_notValid = notValid;
	if (notValid)
		setMifiString("mifiState", "0");
}

function signNotLogging(){
	setLogged(false);
	$('.hd-ico-l i').removeClass('userlogin').addClass('user');
	$('.hd-ico-r i').removeClass('message-active').addClass('message');
}

function signLogged(){
	setLogged(true);
	$('.hd-ico-l i').removeClass('user').addClass('userlogin');
	$('.hd-ico-r i').removeClass('message').addClass('message-active');
	
	mifiRequest("/sms/get" + "?apikey=" + getApikey() + "&mailbox=inbox&offset=0&count=1", queryNewMsg);
}

function init(){
	setMifiString("scheme", "1");
	
	var date = new Date();
	var sTime = date.getDate() + "日" + date.getHours() + "时" + date.getMinutes() + "分";
	setMifiString("refreshTime", sTime);
}

var _switchHintFlag = 0;
var _headerHint = "";
var _ssid = "";
var _intervalId;
function switchHint(){
	var hint = _ssid;
	if (_notValid){
		_switchHintFlag = 2;
	}
	
	switch (_switchHintFlag){
		case 0: 
			hint = "向下拖动屏幕可刷新";
			break;
		case 1:
			hint = _ssid;
			break;
		case 2:
			hint = _headerHint;
			break;
	}
	
	$("#bd .r1 .prompt p").html(hint || "向下拖动屏幕可刷新");
	
	_switchHintFlag = ++_switchHintFlag % 3;
}

function setHeaderHint(sHint){
	_switchHintFlag = 0;
	_headerHint = sHint;
	
	clearInterval(_intervalId);
	switchHint();
	
	if (!_notValid){
		_intervalId = setInterval("switchHint()", 5000);  //15000
	}
}

function dispValid(){
	$("#bd .r2 .flow").css("background-image", "url(images/flow.png)").addClass("valid");
	$("#bd .r2 .share").css("background-image", "url(images/share.png)").addClass("valid");
	$("#bd .r2 .statistics").css("background-image", "url(images/statistics.png)").addClass("valid");
}

function dispNotValid(){
	$("#bd .r2 .flow").css("background-image", "url(images/flow_wlj.png)").removeClass("valid");
	$("#bd .r2 .share").css("background-image", "url(images/share_wlj.png)").removeClass("valid");
	$("#bd .r2 .statistics").css("background-image", "url(images/statistics_wlj.png)").removeClass("valid");
}

function showNotValidStatus(){
	setNotValid(true);
	dispNotValid();
	
	$("#bd .r1 .prompt i").css("background-color", "#FF0000");
	setHeaderHint("MIFI未连接");
	
	$("ul#powerOnTime li.hour,ul#powerOnTime li.minute").each(function(index) {
		  $(this).html("0");
	});
	
	$("#dataUsage strong").html("N/A");
	$("#dataSincePowerOn strong").html("N/A");
	
	//电量显示
	$("div.battery img").attr("src", "images/dlNA.png");
	$("div.battery i").css("background-image", "url(images/dcNA.png)");
	
	//信号显示
	$("div.signal img").attr("src", "images/xhNA.png");
	
	//剩余电量
	//result.dataUsage = 100 * ONEM;  //only for test
	$("div.batterylevel a").html("N/A");
	$("div.batterylevel a").css("background-image", "url(images/llqNA.png)");
	
	$("#dataRemain strong").html("N/A");
	$("#dataRemainPerDay strong").html("N/A");
	$("#remainDays strong").html("N/A");
	
	$("#currentUserCount a").html("0");
	
	showHint(".hintdialog", "未连接有效MIFI设备！");
}

function showStatus(rstJson){
	if (rstJson == null || rstJson.errorCode != 0){
		mifiLog(Base64.toBase64("showStatus failed! json:"+rstJson));
        
		setNotValid(true);
		showNotValidStatus();
		return;  //remark for home test
	} 
	
	setNotValid(false);
	dispValid();
	mifiRequest("/wifi/status" + "?apikey=" + getApikey(), checkLoginStatus);
	
	var result = rstJson.result;
	
	////HOUR
	var sPowerOnTime = Math.floor(result.powerOnTime / 3600) + "";
	var sIndex = sPowerOnTime.length - 1;
	var powerOnTimeArr = [];
	for (var i = 1; i >= 0; i--){
		powerOnTimeArr[i] = (sIndex >= 0) ? sPowerOnTime[sIndex] : "0";
		sIndex--;
	}
	
	$("ul#powerOnTime li.hour").each(function(index) {
		  $(this).html(powerOnTimeArr[index]);
	});
	
	////MINUTE
	sPowerOnTime = Math.floor((result.powerOnTime % 3600) / 60) + "";
	sIndex = sPowerOnTime.length - 1;
	powerOnTimeArr = [];
	for (var i = 1; i >= 0; i--){
		powerOnTimeArr[i] = (sIndex >= 0) ? sPowerOnTime[sIndex] : "0";
		sIndex--;
	}
	
	$("ul#powerOnTime li.minute").each(function(index) {
		  $(this).html(powerOnTimeArr[index]);
	});
	
//	$("#dataUsage strong").html((result.dataUsage / ONEM).toFixed(2));
//	$("#dataSincePowerOn strong").html((result.dataSincePowerOn / ONEM).toFixed(2));
	smartFillData("#dataUsage", result.dataUsage / ONEM);
	smartFillData("#dataSincePowerOn", result.dataSincePowerOn / ONEM);
	
	//电量显示
	var batteryRemain = 100 - result.batteryUsed;
	setMifiString("batteryRem", batteryRemain);
	setMifiString("batteryStatus", result.batteryStatus);
	var battery10 = percentTrans(batteryRemain, 10);
	var battery5 = percentTrans(batteryRemain, 20);
	var inCharge = result.batteryStatus == 1;
	$("div.battery img").attr("src", inCharge ? "images/charging_bar.gif" : "images/dl" + battery5 + ".png");
	$("div.battery i").css("background-image", "url(" + (inCharge ? "images/charging_samll.gif" : "images/dc" + judgeFullState(battery10) + ".png") + ")");
	
	//信号显示
	var signal5 = percentTrans(result.signalStrength, 20);
	var networkType = judgeNetworkType(result.networkType);
	$("div.signal img").attr("src", "images/xh" + (networkType == "1w" ? "NA" : signal5) + ".png");
	$("div.signal i").css("background-image", "url(" + "images/" + networkType + ".png" + ")");
	
	//剩余流量
	//result.dataUsage = 100 * ONEM;  //only for test
	var limitValid = !(result.dataLimit == 0 || result.dataLimit == null);
	var dataRemainPercent = limitValid ? Math.floor((1 - result.dataUsage/(result.dataLimit * ONEM)) * 100) : 0;
	var data10 = percentTrans(dataRemainPercent, 10);
	$("div.batterylevel a").html(limitValid ? (dataRemainPercent) + "%" : "<span style='font-size: 0.8em;color: #fff;'>未设置</span>");
	$("div.batterylevel a").css("background-image", "url(" + "images/llq" + (data10 == 10 ? "" : "0") + data10 + ".png" + ")");
	
	var remain = result.dataLimit * ONEM - result.dataUsage;
	var date = new Date();
	var remainDays = numberOfDays(date.getFullYear(), date.getMonth() + 1, 0) - date.getDate() + 1;
	if (remain <= 0){
		var showM = Math.round(remain / ONEM);
		var showG = showM / 1024;
		
		var data = "";
		var unit = "M";
		if (Math.abs(showG) > 1){
			data = showG.toFixed(0);
			unit = "G";
		} else {
			data = showM.toFixed(0);
			unit = "M";
		}
		$("div.batterylevel a").html(data + unit);
		$("#dataRemain strong").html("0");
		$("#dataRemainPerDay strong").html("0");
	} else {
		//$("#dataRemain strong").html(limitValid ? (remain / ONEM).toFixed(2) : "N/A");
		//$("#dataRemainPerDay strong").html(limitValid ? (remain / remainDays / ONEM).toFixed(2) : "N/A");
		smartFillRemainData("#dataRemain", remain / ONEM, limitValid);
		smartFillRemainData("#dataRemainPerDay", remain / remainDays / ONEM, limitValid);
	}
	
	$("#remainDays strong").html(remainDays);
	
	if (result.dataLimit < 1 || dataRemainPercent < 25){
		var sHint = "";
		if (dataRemainPercent > 20){
			sHint = "剩余流量充足，请放心使用";
			$("#bd .r1 .prompt i").css("background-color", "#31CA13");
			$("div.batterylevel a").css("background-image", "url(" + "images/llq03.png" + ")");
		} else if (dataRemainPercent > 5){
			sHint = "剩余流量不足，请谨慎使用";
			$("#bd .r1 .prompt i").css("background-color", "rgb(236, 147, 49)");
		} else if (dataRemainPercent > 0){
			sHint = "剩余流量严重不足";
			$("#bd .r1 .prompt i").css("background-color", "#f00");
			$("div.batterylevel a").css("background-image", "url(" + "images/llqlow.png" + ")");
		} else {
			sHint = "流量已用尽";
			$("#bd .r1 .prompt i").css("background-color", "#f00");
			$("div.batterylevel a").css("background-image", "url(" + "images/llqover.png" + ")");
		}
		
		setHeaderHint(sHint);
	} else {
		$("#bd .r1 .prompt i").css("background-color", "#31CA13");
		setHeaderHint("剩余流量充足，请放心使用");
	}
	
	$("#currentUserCount a").html(result.currentUserCount);
	
	_ssid = result.ssid || result.model;
	setMifiString("imei", result.imei);
	try{
		var carriers = result.imsi.substr(4,1);
		setMifiString("carriers", carriers);
	} catch (err){
		
	}
}

function smartFillData(id,showM){
	var showG = showM / 1024;
	
	var data = "";
	var unit = "MB";
	if (showG > 1){
		data = showG.toFixed(2);
		unit = "GB";
	} else {
		data = showM.toFixed(2);
		unit = "MB";
	}
	
	$(id + " strong").html(data);
	$(id + " span").html(unit);
}

function smartFillRemainData(id,showM, limitValid){
	var showG = showM / 1024;
	
	var data = "N/A";
	var unit = "MB";
	if (limitValid){
		if (showG > 1){
			data = showG.toFixed(2);
			unit = "GB";
		} else {
			data = showM.toFixed(2);
			unit = "MB";
		}
	}
	
	$(id + " strong").html(data);
	$(id).next().html(unit);
}

function checkLoginStatus(rstJson){
	var logged = (rstJson.errorCode == 0);

	if (logged)
		signLogged();
	else
		signNotLogging();
}

function numberOfDays(year, month) {
    var d = new Date(year, month, 0);
    return d.getDate();
}

function logout(){
	var rstJson = mifiRequest("/admin/logout" + "?apikey=" + getApikey(), null);
	setMifiString("apikey", "");
	
	$('.mark').hide();
	$('.exitlogin').hide();
	signNotLogging();
}

function cancelLogout(){
	$('.mark').hide();
	$('.exitlogin').hide();
}

function initAd(){
	if (!getSkipAd()){
		if (window.deviceType && deviceType == "iOS") {
			if (window.MifiHttp) {
				var ret = MifiHttp.httpGetRequest(adUrlHead+"/ad/201/detail.json");
				var rstJson = JSON.parse(ret);
				showAd(rstJson);
			}
			else {
				console.log("MifiHttp undefined");
			}
		} else {
			mifiRequest("/ad/201/detail.json", showAd, null, null, 1);
		}
	}
}

function showAd(rstJson){
	if (rstJson && rstJson.length > 0){
		var adItem = rstJson[0];
		$(".slide").find("a:first").attr("href", "#");
		$(".slide").find("a:first").attr("onclick", "gotoNewBrowserUrl('" + adItem.url+  "')");
		$(".slide").find("img:first").attr("src", adItem.content);
	}
}

function getWaked(){
	return _waked;
}

function showMark(){
	$('.mark').show();
	goSleep();
}

function markIsVisible(){
	return $(".mark").is(":visible");
}