var _requestJson;
var _ulShowing = false;
var _waked = false;

$(function(){
	/*下拉选项栏*/
		// 显示下拉选项栏
		$('.r2 fieldset:last-child>div div').click(function(){
			_ulShowing = true;
			$(this).next('ul').show();
		});
		
		$("div#bd").click(function(){
			if (_ulShowing){
				_ulShowing = false;
			} else if ($(".r2 fieldset ul").is(":visible")){
				$(".r2 fieldset ul").hide();
			}
		});
		
	/*显示密码*/
		$('#showpasswordbox label').click(function(){
			if ($('#showpassword')[0].checked) {
				$('#password').prop('type','password');
			} else {
				$('#password').prop('type','text');
			}
		});
		
		$('div.save div').click(function(){
			var errInfo = null;
			
			if (!testReg($("#ssid").val(), /^[\w-_#@!$%]*$/)){
				errInfo = "SSID含有无效字符";
			} else if (!testReg($("#password").val(), /^\S*$/) || !testReg($("#password").val(), /^[x00-xff]*$/)){
				errInfo = "密码值含有无效字符";
			} else if (!testReg($("#maxUserCount").val(), /^\d*$/)){
				errInfo = "接入用户数无效";
			} else if ($("#ssid").val().length > 31){
				errInfo = "SSID长度不能超过31";
			} else if (parseInt($("#maxUserCount").val()) > 10 || parseInt($("#maxUserCount").val()) < 1){
				errInfo = "接入用户数不能大于10";
			} else {
				var security = _requestJson.security;
				errInfo = testPwdLength(security, $("#password").val());
			}
			
			goSleep();
			
			if (errInfo){
				$("#hintinfo").html(errInfo);
				$(".cancel-btn").val("关闭");
				$(".cancel-btn").css("margin-left", "3em");
				$(".exit-btn").hide();
			} else {		
				$("#hintinfo").html("保存设置内容 <br>是否继续？");
				$(".cancel-btn").css("margin-left", "0em");
				$(".cancel-btn").val("取 消");
				$(".exit-btn").show();
			}
			
			$('.mark,.hintdialog').show();
		});
		
		mifiRequest("/wifi/status" + "?apikey=" + getApikey(), showWifiStatus);
		wakedPage();
});

function testPwdLength(security, password){
	var rst = null;
	
	var regExp = new RegExp("^[x00-xff]{" + wifiPasswordLength[security] + "}$");
	if (!regExp.test(password)){
		var arr = wifiPasswordLength[security].split(",");
		if (arr.length == 2){
			rst = "密码长度必须在" + arr[0] + "到" + arr[1] + "之间";
		} else {
			rst = "密码长度必须为" + arr[0];
		}
	}
	
	return rst;
}

function getWaked(){
	return _waked;
}

function testReg(s, re){
	var rst = false;
	if(re.test(s)){  
	    rst = true;  
	}
	
	return rst;
}

function saveOk(){
	if (!_waked)
		return;
	
	$('.mark,.hintdialog').hide();
	
	_requestJson.ssid = $("#ssid").val();
	_requestJson.password = btoa($("#password").val());  //设置密码报错
	_requestJson.maxUserCount = parseInt($("#maxUserCount").val());
	mifiRequest("/wifi/set" + "?apikey=" + getApikey(), function(rstJson){
		if (rstJson.errorCode != 0)
			return;
		$('.mark,.restart').show();
	}, "POST", _requestJson);
}

function saveCancel(){
	if (!_waked)
		return;
	
	$('.mark,.hintdialog').hide();
}

function showWifiStatus(rstJson){
	if (rstJson.errorCode != 0)
		return;
	
	var result = rstJson.result;
	_requestJson = {};
	_requestJson.ssid = result.ssid;
	_requestJson.security = result.security;
	_requestJson.password = result.password;
	_requestJson.broadcast = result.broadcast;
	_requestJson.maxUserCount = result.maxUserCount;
	_requestJson.mode = result.mode;
	
	$("#ssid").val(result.ssid);
	$("#password").val(atob(result.password));
	$("#maxUserCount").val(result.maxUserCount);
	
	$("#security").html(wifiSecurityModeAll[result.security]);
	
	//密码长度限制说明
	var arr = wifiPasswordLength[result.security].split(",");
	var hint;
	if (arr.length == 2){
		hint = arr[0] + "到" + arr[1] + "位";
	} else {
		hint = arr[0] + "位";
	}
	
	$("#pwdLimit").html(hint);
	
	//为了解决界面刷新的问题
	$("#tempChk").prop("checked", true);
	$("#tempChk").hide();
}